DATA hght_long;
	INFILE 'C:\GRE2016\Data\bgs_height_long.dat';
	INPUT id age hght;
RUN;

*Jenss-Bayley Model - Model 1;
PROC NLMIXED DATA = hght_long QPOINTS = 5;
	traject = b_1i + b_2i * age/12 - exp(b_3i + gamma*(age/12));

	MODEL hght ~ NORMAL(traject, v_u);
	RANDOM b_1i b_2i b_3i ~ NORMAL([beta_1,beta_2,beta_3], [v_1,
									                       c_21,  v_2,
                                                           c_31, c_32, v_3])
	SUBJECT = id;
	PARMS	
		beta_1 = 70	beta_2 = 10 beta_3 = 3	gamma = -2
	
		v_1 = 8		v_2 = 1		v_3 = 9
		c_21 = 0	c_31 = 0	c_32 = 0

		v_u = 2;
RUN;

/*
                                         Fit Statistics

                            -2 Log Likelihood                 1989.8
                            AIC (smaller is better)           2011.8
                            AICC (smaller is better)          2012.2
                            BIC (smaller is better)           2038.4


                                      Parameter Estimates

                       Standard
  Parameter  Estimate     Error    DF  t Value  Pr > |t|   Alpha     Lower     Upper  Gradient

  beta_1      68.9766    0.4669    80   147.74    <.0001    0.05   68.0474   69.9057  0.000044
  beta_2       9.2734    0.1722    80    53.86    <.0001    0.05    8.9307    9.6161  0.000197
  beta_3       2.8708   0.02563    80   112.03    <.0001    0.05    2.8198    2.9218  0.000145
  gamma       -2.0632   0.07911    80   -26.08    <.0001    0.05   -2.2206   -1.9058  -0.00009
  v_1          6.9339    1.3357    80     5.19    <.0001    0.05    4.2758    9.5920  -3.86E-6
  v_2          0.7026    0.1766    80     3.98    0.0002    0.05    0.3510    1.0541   0.00005
  v_3         0.02684  0.006553    80     4.10    0.0001    0.05   0.01380   0.03988  0.002391
  c_21        0.02082    0.3576    80     0.06    0.9537    0.05   -0.6908    0.7324  0.000057
  c_31         0.2253   0.07608    80     2.96    0.0040    0.05   0.07385    0.3767  0.000159
  c_32       -0.02205   0.02525    80    -0.87    0.3852    0.05  -0.07230   0.02821  0.000495
  v_u          0.6926   0.05233    80    13.24    <.0001    0.05    0.5884    0.7967  -0.00006

NOTE: PROCEDURE NLMIXED used (Total process time):
      real time           9.28 seconds
*/

*Jenss-Bayley Model - Model 2;
PROC NLMIXED DATA = hght_long QPOINTS = 5;
	traject = b_1i + b_2i * age/12 + b_3i * exp(gamma*(age/12));

	MODEL hght ~ NORMAL(traject, v_u);
	RANDOM b_1i b_2i b_3i ~ NORMAL([beta_1,beta_2,beta_3], [v_1,
									                       c_21,  v_2,
                                                           c_31, c_32, v_3])
	SUBJECT = id;
	PARMS	
		beta_1 = 70	beta_2 = 10 beta_3 = -18	gamma = -2
	
		v_1 = 8		v_2 = 1		v_3 = 9
		c_21 = 0	c_31 = 0	c_32 = 0

		v_u = 2;
RUN;

/*
                                         Fit Statistics

                            -2 Log Likelihood                 1978.1
                            AIC (smaller is better)           2000.1
                            AICC (smaller is better)          2000.6
                            BIC (smaller is better)           2026.7


                                      Parameter Estimates

                       Standard
  Parameter  Estimate     Error    DF  t Value  Pr > |t|   Alpha     Lower     Upper  Gradient

  beta_1      68.9727    0.4658    80   148.07    <.0001    0.05   68.0457   69.8997  -1.74E-6
  beta_2       9.2749    0.1723    80    53.84    <.0001    0.05    8.9320    9.6177  0.000013
  beta_3     -17.8812    0.4635    80   -38.58    <.0001    0.05  -18.8036  -16.9588  2.029E-7
  gamma       -2.0634   0.07804    80   -26.44    <.0001    0.05   -2.2187   -1.9081  0.000031
  v_1          7.0931    1.3709    80     5.17    <.0001    0.05    4.3650    9.8212  -4.64E-7
  v_2          0.7395    0.1812    80     4.08    0.0001    0.05    0.3790    1.1001  1.144E-6
  v_3          9.4221    2.1462    80     4.39    <.0001    0.05    5.1511   13.6931  -1.67E-6
  c_21       -0.05514    0.3701    80    -0.15    0.8819    0.05   -0.7917    0.6814  0.000011
  c_31        -4.5628    1.4480    80    -3.15    0.0023    0.05   -7.4445   -1.6812  1.913E-6
  c_32         0.6703    0.4894    80     1.37    0.1747    0.05   -0.3037    1.6442  0.000013
  v_u          0.6710   0.05003    80    13.41    <.0001    0.05    0.5714    0.7705  -0.00002

NOTE: PROCEDURE NLMIXED used (Total process time):
      real time           5.44 seconds
*/

*Jenss-Bayley Model - Model 3;
PROC NLMIXED DATA = hght_long;
    traject = b_1i + b_2i * (age/12) + b_3i * (exp(gamma*(age/12))-1);
    MODEL hght ~ NORMAL(traject, v_u);
    RANDOM b_1i b_2i b_3i ~ NORMAL([beta_1,beta_2,beta_3], [v_1,
                                                           c_21,  v_2,
                                                           c_31, c_32, v_3])
    SUBJECT = id OUT = jb_estimates;
    PARMS
        beta_1 = 50   beta_2 = 10    beta_3 = -18    gamma = -2
        v_1 = 8       v_2 = 1        v_3 = 9           
        c_21 = 0      c_31 = 0       c_32 = 0
        v_u = 2;
RUN;
/*
                                         Fit Statistics

                            -2 Log Likelihood                 1978.1
                            AIC (smaller is better)           2000.1
                            AICC (smaller is better)          2000.6
                            BIC (smaller is better)           2026.7

                                      The NLMIXED Procedure

                                      Parameter Estimates

                       Standard
  Parameter  Estimate     Error    DF  t Value  Pr > |t|   Alpha     Lower     Upper  Gradient

  beta_1      51.0915    0.3524    80   144.98    <.0001    0.05   50.3902   51.7928  0.000025
  beta_2       9.2749    0.1723    80    53.84    <.0001    0.05    8.9320    9.6177  -0.00002
  beta_3     -17.8812    0.4635    80   -38.58    <.0001    0.05  -18.8036  -16.9588  2.419E-7
  gamma       -2.0634   0.07804    80   -26.44    <.0001    0.05   -2.2187   -1.9081  -0.00029
  v_1          7.3895    1.3519    80     5.47    <.0001    0.05    4.6991   10.0799    2.7E-6
  v_2          0.7395    0.1812    80     4.08    0.0001    0.05    0.3790    1.1001  -5.63E-6
  v_3          9.4221    2.1462    80     4.39    <.0001    0.05    5.1510   13.6931  -1.59E-7
  c_21         0.6151    0.3748    80     1.64    0.1047    0.05   -0.1308    1.3610  1.563E-6
  c_31         4.8592    1.4200    80     3.42    0.0010    0.05    2.0333    7.6851  -0.00001
  c_32         0.6703    0.4894    80     1.37    0.1747    0.05   -0.3037    1.6442   0.00002
  v_u          0.6710   0.05003    80    13.41    <.0001    0.05    0.5714    0.7705  -0.00005

NOTE: PROCEDURE NLMIXED used (Total process time):
      real time           0.25 seconds
*/


* Individual Predicted Plot;
PROC SORT DATA = jb_estimates;
	BY id;
RUN;
DATA jb_estimates_b1;
	SET jb_estimates;
	IF effect = 'b_1i';
	b_1i = estimate;
	KEEP id b_1i;
RUN;
DATA jb_estimates_b2;
	SET jb_estimates;
	IF effect = 'b_2i';
	b_2i = estimate;
	KEEP id b_2i;
RUN; 
DATA jb_estimates_b3;
	SET jb_estimates;
	IF effect = 'b_3i';
	b_3i = estimate;
	KEEP id b_3i;
RUN;

DATA jb_estimates1;
	MERGE 	jb_estimates_b1 
			jb_estimates_b2 
			jb_estimates_b3; 
	BY id;
RUN;
 
*Creating a longitudinal database with predictions;
DATA jb_prediction;
	MERGE hght_long jb_estimates1;
	BY id;
	gamma = -2.0634;
	pred = b_1i + b_2i * age/12 + b_3i * (exp(gamma*(age/12))-1);
	resid = hght - pred;
RUN;
GOPTIONS
	FTEXT = ARIAL
	CTEXT = BLACK
	HTEXT = 1.5;
PROC GPLOT DATA = jb_prediction;
	TITLE1 'IGS Height by Age - JB Predictions';
	SYMBOL
		Interpol=join
		Color=black
		Repeat=5000
		Value=dot
		Height=.5
		Width=1;
	AXIS1
		LABEL = (F=ARIAL H = 2 A=90 'Height (cm)')
		ORDER = (40 to 110 BY 10)
		MINOR = none
		OFFSET= (5 pct 5 pct);
	AXIS2
		LABEL = (F=ARIAL H = 2 'Age in Months')	
		ORDER = (0 to 40 BY 10)
		MINOR = none
		OFFSET= (5 PCT, 5 PCT);
	PLOT pred * age = id/NOLEGEND VAXIS= AXIS1 HAXIS=AXIS2;
RUN;

DATA jb_prediction1;
	SET jb_estimates1;
	gamma = -2.0634;
	DO age = 1 to 36 by .5;
		pred = b_1i + b_2i * age/12 + b_3i * (exp(gamma*(age/12))-1);
	OUTPUT;
	END;
RUN;


PROC GPLOT DATA = jb_prediction1;
	TITLE1 'IGS Height by Age - JB Predictions';
	SYMBOL
		Interpol=smooth
		Color=black
		Repeat=5000
		Value=none
		Height=.5
		Width=1;
	AXIS1
		LABEL = (F=ARIAL H = 2 A=90 'Height (cm)')
		ORDER = (40 to 110 BY 10)
		MINOR = none
		OFFSET= (5 pct 5 pct);
	AXIS2
		LABEL = (F=ARIAL H = 2 'Age in Months')	
		ORDER = (0 to 40 BY 10)
		MINOR = none
		OFFSET= (5 PCT, 5 PCT);
	PLOT pred * age = id/NOLEGEND VAXIS= AXIS1 HAXIS=AXIS2;
RUN;

****  Latent Basis Model  ****;
PROC NLMIXED DATA = hght_long;
    IF age = 1  THEN A_t = 0;
    IF age = 3  THEN A_t = A_2;
    IF age = 6  THEN A_t = A_3;
    IF age = 9  THEN A_t = A_4;
    IF age = 12 THEN A_t = A_5;
    IF age = 15 THEN A_t = A_6;
    IF age = 18 THEN A_t = A_7;
    IF age = 24 THEN A_t = A_8;
    IF age = 36 THEN A_t = 1; 

    traject = b_1i + b_2i * A_t;

    MODEL hght ~ NORMAL(traject, v_u);
    RANDOM b_1i b_2i ~ NORMAL([beta_1,beta_2], [v_1,
                                               c_21,  v_2])

    SUBJECT = id OUT = lb_estimates;
    PARMS
         beta_1 = 40 beta_2 = 15
         A_2 = .2    A_3 = .3    A_4 = .4   A_5 = .6   A_6 = .7   A_7 = .8   A_8 = .9
         v_1 = 40    v_2 = 1     c_21 = 0
         v_u = 10;
RUN; 

/*
                                         Fit Statistics

                            -2 Log Likelihood                 1996.2
                            AIC (smaller is better)           2022.2
                            AICC (smaller is better)          2022.8
                            BIC (smaller is better)           2053.6


                                      Parameter Estimates

                       Standard
  Parameter  Estimate     Error    DF  t Value  Pr > |t|   Alpha     Lower     Upper  Gradient

  beta_1      54.5425    0.2778    81   196.36    <.0001    0.05   53.9899   55.0952   -0.0007
  beta_2      42.1001    0.4087    81   103.00    <.0001    0.05   41.2868   42.9133  0.000175
  A_2          0.1471  0.003538    81    41.57    <.0001    0.05    0.1400    0.1541  -0.01821
  A_3          0.3088  0.003426    81    90.15    <.0001    0.05    0.3020    0.3156   -0.0098
  A_4          0.4096  0.003392    81   120.75    <.0001    0.05    0.4028    0.4163  0.005591
  A_5          0.5030  0.003350    81   150.12    <.0001    0.05    0.4963    0.5096  -0.01422
  A_6          0.5871  0.003551    81   165.35    <.0001    0.05    0.5800    0.5942  0.005325
  A_7          0.6568  0.003552    81   184.92    <.0001    0.05    0.6498    0.6639  0.006554
  A_8          0.7833  0.003641    81   215.12    <.0001    0.05    0.7760    0.7905  -0.00657
  v_1          5.1383    0.8886    81     5.78    <.0001    0.05    3.3704    6.9063  -0.00031
  v_2         10.2310    1.9807    81     5.17    <.0001    0.05    6.2900   14.1720  -0.00006
  c_21        -0.9285    0.9730    81    -0.95    0.3428    0.05   -2.8644    1.0074  -0.00017
  v_u          0.8158   0.05636    81    14.48    <.0001    0.05    0.7037    0.9279  0.000667
*/


* Individual Predicted Plot;
PROC SORT DATA = lb_estimates;
	BY id;
RUN;
DATA lb_estimates_b1;
	SET lb_estimates;
	IF effect = 'b_1i';
	b_1i = estimate;
	KEEP id b_1i;
RUN;
DATA lb_estimates_b2;
	SET lb_estimates;
	IF effect = 'b_2i';
	b_2i = estimate;
	KEEP id b_2i;
RUN; 

DATA lb_estimates1;
	MERGE 	lb_estimates_b1 
			lb_estimates_b2; 
	BY id;
RUN;
 
*Creating a longitudinal database with predictions;
DATA lb_prediction;
	MERGE hght_long lb_estimates1;
	BY id;

	ARRAY A_t[9] (0, .1471, .3088, .4096, .5030, .5871, .6568, 7833, 1);
	ARRAY time[9] (1,3,6,9,12,15,18,24,36);

	DO I = 1 to 9;
		IF age = time[I] THEN pred = b_1i + b_2i * A_t[I];
	END;
	resid = hght - pred;
RUN;
GOPTIONS
	FTEXT = ARIAL
	CTEXT = BLACK
	HTEXT = 1.5;
PROC GPLOT DATA = lb_prediction;
	TITLE1 'IGS Height by Age - Latent Basis Predictions';
	SYMBOL
		Interpol=join
		Color=black
		Repeat=5000
		Value=none
		Height=.5
		Width=1;
	AXIS1
		LABEL = (F=ARIAL H = 2 A=90 'Height (cm)')
		ORDER = (40 to 110 BY 10)
		MINOR = none
		OFFSET= (5 pct 5 pct);
	AXIS2
		LABEL = (F=ARIAL H = 2 'Age in Months')	
		ORDER = (0 to 40 BY 10)
		MINOR = none
		OFFSET= (5 PCT, 5 PCT);
	PLOT pred * age = id/NOLEGEND VAXIS= AXIS1 HAXIS=AXIS2;
RUN;


* Spline Model with Estimated Knot Point;
PROC NLMIXED DATA = hght_long;
    traject = b_1i + b_2i*(MIN(age-gamma,0)) + b_3i*(MAX(age-gamma,0));

    MODEL hght ~ NORMAL(traject, v_u);
    RANDOM b_1i b_2i b_3i ~ NORMAL([beta_1,beta_2,beta_3], [v_1,
                                                           c_21,  v_2,
                                                           c_31, c_32, v_3])
    SUBJECT = id OUT = sp_estimates;
    PARMS
        beta_1 = 70  beta_2 = 7   beta_3 = .5   gamma = 9
        v_1 = 8      v_2 = 1      v_3 = 1
        c_21 = 0     c_31 = 0     c_32 = 0
        v_u = 2;
RUN;

/*
                                         Fit Statistics

                            -2 Log Likelihood                 2264.7
                            AIC (smaller is better)           2286.7
                            AICC (smaller is better)          2287.2
                            BIC (smaller is better)           2313.3


                                      Parameter Estimates

                       Standard
  Parameter  Estimate     Error    DF  t Value  Pr > |t|   Alpha     Lower     Upper  Gradient

  beta_1      71.6880    0.3330    80   215.27    <.0001    0.05   71.0253   72.3508  -0.00065
  beta_2       2.5653   0.05274    80    48.64    <.0001    0.05    2.4603    2.6702   0.00005
  beta_3       0.9031  0.009926    80    90.98    <.0001    0.05    0.8833    0.9228  0.000156
  gamma        7.5167    0.1330    80    56.50    <.0001    0.05    7.2519    7.7815  0.000871
  v_1          5.9071    1.0457    80     5.65    <.0001    0.05    3.8261    7.9880  -0.00024
  v_2         0.06967   0.02047    80     3.40    0.0010    0.05   0.02892    0.1104  0.002703
  v_3        0.003272  0.001122    80     2.91    0.0046    0.05  0.001038  0.005505  -0.00998
  c_21         0.2656    0.1123    80     2.36    0.0205    0.05   0.04205    0.4891  0.002041
  c_31        0.07563   0.02490    80     3.04    0.0032    0.05   0.02607    0.1252  0.004618
  c_32       0.008192  0.003366    80     2.43    0.0172    0.05  0.001493   0.01489  -0.00572
  v_u          1.4758    0.1103    80    13.38    <.0001    0.05    1.2563    1.6954  0.000147
*/

* Individual Predicted Plot;
PROC SORT DATA = sp_estimates;
	BY id;
RUN;
DATA sp_estimates_b1;
	SET sp_estimates;
	IF effect = 'b_1i';
	b_1i = estimate;
	KEEP id b_1i;
RUN;
DATA sp_estimates_b2;
	SET sp_estimates;
	IF effect = 'b_2i';
	b_2i = estimate;
	KEEP id b_2i;
RUN; 
DATA sp_estimates_b3;
	SET sp_estimates;
	IF effect = 'b_3i';
	b_3i = estimate;
	KEEP id b_3i;
RUN;
DATA sp_estimates1;
	MERGE 	sp_estimates_b1 
			sp_estimates_b2 
			sp_estimates_b3; 
	BY id;
RUN;
 
*Creating a longitudinal database with predictions;
DATA sp_prediction;
	MERGE hght_long sp_estimates1;
	BY id;

	gamma = 7.5167;
	pred = b_1i + b_2i*(MIN(age-gamma,0)) + b_3i*(MAX(age-gamma,0));

	resid = hght - pred;
RUN;
GOPTIONS
	FTEXT = ARIAL
	CTEXT = BLACK
	HTEXT = 1.5;
PROC GPLOT DATA = sp_prediction;
	TITLE1 'IGS Height by Age - Spline Predictions';
	SYMBOL
		Interpol=join
		Color=black
		Repeat=5000
		Value=dot
		Height=.5
		Width=1;
	AXIS1
		LABEL = (F=ARIAL H = 2 A=90 'Height (cm)')
		ORDER = (40 to 110 BY 10)
		MINOR = none
		OFFSET= (5 pct 5 pct);
	AXIS2
		LABEL = (F=ARIAL H = 2 'Age in Months')	
		ORDER = (0 to 40 BY 10)
		MINOR = none
		OFFSET= (5 PCT, 5 PCT);
	PLOT pred * age = id/NOLEGEND VAXIS= AXIS1 HAXIS=AXIS2 HREF=7.5167;
RUN;


DATA sp_prediction1;
	SET sp_estimates1;
	gamma = 7.5167;
	DO age = 1 to 36 by .5;
	pred = b_1i + b_2i*(MIN(age-gamma,0)) + b_3i*(MAX(age-gamma,0));
	OUTPUT;
	END;
RUN;

PROC GPLOT DATA = sp_prediction1;
	TITLE1 'IGS Height by Age - Spline Predictions';
	SYMBOL
		Interpol=join
		Color=black
		Repeat=5000
		Value=none
		Height=.5
		Width=1;
	AXIS1
		LABEL = (F=ARIAL H = 2 A=90 'Height (cm)')
		ORDER = (40 to 110 BY 10)
		MINOR = none
		OFFSET= (5 pct 5 pct);
	AXIS2
		LABEL = (F=ARIAL H = 2 'Age in Months')	
		ORDER = (0 to 40 BY 10)
		MINOR = none
		OFFSET= (5 PCT, 5 PCT);
	PLOT pred * age = id/NOLEGEND VAXIS= AXIS1 HAXIS=AXIS2 HREF=7.5167;
RUN;













